<template>
    <fragment>
        <div :class="[`box-table-header`, {'bg-red c-white': redThead},{'box-table__header':toDayDateMatch}]">
            <div class="cell cell-datetime">{{ formattedMatchDate }}</div>
            <div class="cell cell-team cell-empty"></div>
            <div
                v-if="arrItemsHaveSome(items, ['event', 'scoreboard', 'results'])"
                class="cell cell-score"
            >Score</div>
            <div class="cell cell-one">1</div>
            <div class="cell cell-x">X</div>
            <div class="cell cell-two">2</div>
            <div class="cell cell-play cell-empty"></div>
        </div>
        <div class="box-table-body">
            <router-link
                :to="`/football/match/${item.event.id}`"
                v-for="(item, idx) in items"
                :key="idx"
                class="row"
            >
                <div class="cell cell-datetime">
                    <div v-if="item.icon" :class="['icon', `icon-${item.icon}`]"></div>
                    <div :class="[
                        'text',
                        {'red': item.red}
                    ]">
                        {{ dateToTime(item.start_date) }}
                    </div>
                </div>
                <div class="cell cell-team">
                    <div v-for="(team, teamIdx) in item.participants" v-if="teamIdx < 2" :key="teamIdx" class="item">
                        <span
                            class="team-logo"
                            :style="{ backgroundImage: teamLogo(team) }"
                        ></span>
                        <div :class="['team-name', {'team-winner': team.winner}]">{{ team.name }}</div>
                    </div>
                </div>
                <div v-if="item.event && item.event.scoreboard" class="cell cell-score">
                    <span :class="['bubble', {'bubble-red': item.red}]">{{ item.event.scoreboard.results.split(':').join(' : ') }}</span>
                </div>
                <div  class="cell cell-one">
                    <span class="bubble">
                        {{ checkBetOfType(item.event.bets, '1') ? toFloatFixed(getBetOfType(item.event.bets, '1')['average_price']) : '-' }}
                    </span>
                </div>
                <div  class="cell cell-x">
                    <span class="bubble">
                        {{ checkBetOfType(item.event.bets, 'X') ? toFloatFixed(getBetOfType(item.event.bets, 'X')['average_price']) : '-' }}
                    </span>
                </div>
                <div  class="cell cell-two">
                    <span class="bubble">
                        {{ checkBetOfType(item.event.bets, '2') ? toFloatFixed(getBetOfType(item.event.bets, '2')['average_price']) : '-' }}
                    </span>
                </div>
                <div  class="cell cell-play">
                    <span class="play-btn"></span>
                </div>
            </router-link>
        </div>
    </fragment>
</template>

<script>
import { Fragment } from 'vue-fragment'
import moment from 'moment'
import { mapGetters, mapActions,mapMutations } from 'vuex'

function checkNested(obj) {
    let args = Array.prototype.slice.call(arguments, 1);

    for (var i = 0; i < args.length; i++) {
        if (!obj || !obj.hasOwnProperty(args[i])) {
            return false;
        }
        obj = obj[args[i]];
    }
    return true;
}

export default {
    name: 'LeagueMatchesTable',
    props: {
        date: String,
        redThead: {
            type: Boolean,
            default: false
        },
        items: Array
    },
    components: {
        Fragment,

    },
    methods: {
        arrItemsHaveSome(arr, fieldPath) {
            return arr.some((item) => {
                return checkNested(item, ...fieldPath)
            })
        },
        formattedDate(dateString) {
            return moment(dateString, 'YYYY-MM-DDTHH:mm:ss').add(this.$store.getters.headerClockTimezoneOffset,'h').format('DD MMM YYYY')
        },

        dateToTime(dateString) {
            return moment(dateString, 'YYYY-MM-DDTHH:mm:ss').add(this.$store.getters.headerClockTimezoneOffset,'h').format('HH:mm')
        },
        getBetOfType(betsArray, type) {
            return betsArray.filter(bet => bet.name === type)[0]
        },
        checkBetOfType(betsArray, type) {
            return betsArray.filter(bet => bet.name === type).length
        },
        toFloatFixed(val) {
            return parseFloat(val).toFixed(2)
        },
        teamLogo(team) {
            if(team.image !==null){
                return `url('${window.location.origin}/storage/${team.image}')`
            }
            if(team.team_image !==null){
                return `url('${window.location.origin}/storage/${team.team_image}')`
            }
            return  `url('${window.location.origin}/img/team_placeholder.svg')`;
        },
    },
    computed: {
        ...mapGetters(['headerClockTime','headerClockTimezoneOffset','headerClockDate']),
        formattedMatchDate() {
            return moment.unix(this.date).format('DD MMM YYYY')
        },
        toDayDateMatch() {

            if( this.formattedMatchDate === moment().format('DD MMM YYYY') ){
                return true;
            }
            else{
                return false;
            }
        },

    },
    mounted() {
        // this.$log.debug('this.bets', this.listItems)
    },
    watch: {
        items(val) {
        }
    }
}
</script>
